
using System;
using System.Data.SQLite;

namespace Dizzy
{


	public static class GlobalConfig
	{
		public static string password;
		private static bool _authenticated;
		public static bool authenticated {
			get {
				lock(typeof(GlobalConfig)) { return _authenticated; }
			}
			set {
				lock(typeof(GlobalConfig)) { _authenticated = value; }
			}
		}
		private static SQLiteConnection conn;
		
		private static string val;
		
		static GlobalConfig ()
		{
			conn = new SQLiteConnection ("Data Source=" + DataBaseName () + ";Version=3;");
			// Controlliamo che il database sia correttamente
			// inizializzato. 
			Init ();
		}
		
		public static string GetValue(string field)
		{

		lock(conn) {
				SQLiteCommand sqlCmd;
				conn.Open ();
				sqlCmd = conn.CreateCommand ();
				
				sqlCmd.CommandText = "SELECT value FROM config WHERE field = '" + field + "';";
				SQLiteDataReader reader = sqlCmd.ExecuteReader ();
				if (reader.Read())
					val = reader.GetString(0);
				else
					val  = "";
				conn.Close ();
				return val;
			}
		}
		
		public static void InsertValue(string field, string val)
		{
			lock(conn) {
				SQLiteCommand sqlCmd;
			
				conn.Open ();
				sqlCmd = conn.CreateCommand ();
			
				sqlCmd.CommandText = "INSERT OR REPLACE INTO config VALUES ('" + field + "', '" + val + "');";
				sqlCmd.ExecuteNonQuery ();
				conn.Close ();
			}
		}
		
		private static void Init ()
		{
		lock(conn) {
			SQLiteCommand sqlCmd;
			conn.Open ();
			sqlCmd = conn.CreateCommand ();
			
			sqlCmd.CommandText = "SELECT * FROM sqlite_master WHERE type='table';";
			SQLiteDataReader reader = sqlCmd.ExecuteReader ();
			
			if(!reader.HasRows)
			{
				conn.Close ();
				InitialSetup ();
			}
			else 
				conn.Close ();
			}
		}
		
		private static void InitialSetup ()
		{
		
				// Dobbiamo creare la struttura del database
				SQLiteCommand sqlCmd;
				conn.Open ();
				
				// Tabelle delle configurazioni
				sqlCmd = conn.CreateCommand ();
				sqlCmd.CommandText = "CREATE TABLE config (field TEXT PRIMARY KEY, value TEXT);";
				sqlCmd.ExecuteNonQuery ();
				
				// Tabella della lista
				sqlCmd = conn.CreateCommand ();
				sqlCmd.CommandText = "CREATE TABLE list (path TEXT PRIMARY KEY, user TEXT);";
				sqlCmd.ExecuteNonQuery ();
				
				conn.Close ();
			
		}
		
		public static string ConfigDir ()
		{
			string dir = "";
			if (System.Environment.OSVersion.ToString ().Contains("Windows"))
			{
				
				System.Reflection.Assembly a = System.Reflection.Assembly.GetEntryAssembly ();
				dir = System.IO.Path.GetDirectoryName (a.Location);
				
			}
			else // Assumiamo qualcosa di Unix-like
			{
				dir = System.Environment.GetEnvironmentVariable("HOME");
				dir += System.IO.Path.DirectorySeparatorChar + ".dizzy";
			}
			if (!System.IO.Directory.Exists(dir))
				System.IO.Directory.CreateDirectory (dir);
			return dir;
		}
		
		public static string ListFileName () 
		{ 
			return ConfigDir () + System.IO.Path.DirectorySeparatorChar + "index.db";
		}
		
		private static string DataBaseName ()
		{	
			string db = ConfigDir () + System.IO.Path.DirectorySeparatorChar + "config.sqlite";
			if (!System.IO.File.Exists (db))
				System.IO.File.Create (db);
			return db;
		}
	}
	
}
